Resources (Internal)

Structures, Enums and Functions that are not exposed to applications. More...

## Data Structures

struct | coap_attr_t
| Abstraction of attribute associated with a resource. More...
struct | coap_resource_t
| Abstraction of resource that can be attached to coap_context_t. More...

## Macros

#define | RESOURCES_ADD(r, obj) HASH_ADD(hh, (r), uri_path->s[0], (obj)->uri_path->length, (obj))
#define | RESOURCES_DELETE(r, obj) HASH_DELETE(hh, (r), (obj))
#define | RESOURCES_ITER(r, tmp)
#define | RESOURCES_FIND(r, k, res)

## Functions

void | coap_delete_all_resources (coap_context_t *context)
| Deletes all resources from given `context` and frees their storage. More...
void | coap_delete_attr (coap_attr_t *attr)
| Deletes an attribute. More...
coap_print_status_t | coap_print_wellknown (coap_context_t *, unsigned char *, size_t *, size_t, coap_opt_t *)
| Prints the names of all known resources to `buf`. More...

## Detailed Description

Structures, Enums and Functions that are not exposed to applications.

## Macro Definition Documentation

## RESOURCES_ADD

#define RESOURCES_ADD | ( |  | r,
|  |  | obj
| ) |  | HASH_ADD(hh, (r), uri_path->s[0], (obj)->uri_path->length, (obj))

Definition at line 110 of file coap_resource_internal.h.

## RESOURCES_DELETE

#define RESOURCES_DELETE | ( |  | r,
|  |  | obj
| ) |  | HASH_DELETE(hh, (r), (obj))

Definition at line 113 of file coap_resource_internal.h.

## RESOURCES_FIND

#define RESOURCES_FIND | ( |  | r,
|  |  | k,
|  |  | res
| ) |  |

Value:
{ \
HASH_FIND(hh, (r), (k)->s, (k)->length, (res)); \
}

Definition at line 120 of file coap_resource_internal.h.

## RESOURCES_ITER

#define RESOURCES_ITER | ( |  | r,
|  |  | tmp
| ) |  |

Value:
coap_resource_t *tmp, *rtmp; \
HASH_ITER(hh, (r), tmp, rtmp)
coap_resource_t
Abstraction of resource that can be attached to coap_context_t.
Definition: coap_resource_internal.h:42

Definition at line 116 of file coap_resource_internal.h.

## Function Documentation

## coap_delete_all_resources()

void coap_delete_all_resources | ( | coap_context_t * | context | ) |

Deletes all resources from given `context` and frees their storage.

Parameters

  context | The CoAP context with the resources to be deleted.

Definition at line 590 of file resource.c.

Here is the call graph for this function:
Here is the caller graph for this function:

## coap_delete_attr()

void coap_delete_attr | ( | coap_attr_t * | attr | ) |

Deletes an attribute.

Note: This is for internal use only, as it is not deleted from its chain.

Parameters

  attr | Pointer to a previously created attribute.

Definition at line 468 of file resource.c.

Here is the call graph for this function:
Here is the caller graph for this function:

## coap_print_wellknown()

coap_print_status_t coap_print_wellknown | ( | coap_context_t * | context,
|  | unsigned char * | buf,
|  | size_t * | buflen,
|  | size_t | offset,
|  | coap_opt_t * | query_filter
| ) |  |

Prints the names of all known resources to `buf`.

This function sets `buflen` to the number of bytes actually written and returns `1` on succes. On error, the value in `buflen` is undefined and the return value will be `0`.

Parameters

  context | The context with the resource map.
  buf | The buffer to write the result.
  buflen | Must be initialized to the maximum length of `buf` and will be set to the length of the well-known response on return.
  offset | The offset in bytes where the output shall start and is shifted accordingly with the characters that have been processed. This parameter is used to support the block option.
  query_filter | A filter query according to Link Format

Returns
  COAP_PRINT_STATUS_ERROR on error. Otherwise, the lower 28 bits are set to the number of bytes that have actually been written to `buf`. COAP_PRINT_STATUS_TRUNC is set when the output has been truncated.

Definition at line 171 of file resource.c.

Here is the call graph for this function:
Here is the caller graph for this function: